1#!/bin/sh
2#
3#	aegis - project change supervisor
4#	Copyright (C) 2002, 2006-2008 Peter Miller
5#
6#	This program is free software; you can redistribute it and/or modify
7#	it under the terms of the GNU General Public License as published by
8#	the Free Software Foundation; either version 3 of the License, or
9#	(at your option) any later version.
10#
11#	This program is distributed in the hope that it will be useful,
12#	but WITHOUT ANY WARRANTY; without even the implied warranty of
13#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14#	GNU General Public License for more details.
15#
16#	You should have received a copy of the GNU General Public License
17#	along with this program. If not, see
18#	<http://www.gnu.org/licenses/>.
19#
20
21unset AEGIS_PROJECT
22unset AEGIS_CHANGE
23unset AEGIS_PATH
24unset AEGIS
25umask 022
26
27LINES=24
28export LINES
29COLS=80
30export COLS
31
32USER=${USER:-${LOGNAME:-`whoami`}}
33
34work=${AEGIS_TMP:-/tmp}/$$
35PAGER=cat
36export PAGER
37AEGIS_FLAGS="delete_file_preference = no_keep; \
38	lock_wait_preference = always; \
39	diff_preference = automatic_merge; \
40	pager_preference = never; \
41	persevere_preference = all; \
42	log_file_preference = never;"
43export AEGIS_FLAGS
44AEGIS_THROTTLE=-1
45export AEGIS_THROTTLE
46
47here=`pwd`
48if test $? -ne 0 ; then exit 2; fi
49
50bin=$here/${1-.}/bin
51
52pass()
53{
54	set +x
55	echo PASSED 1>&2
56	cd $here
57	find $work -type d -user $USER -exec chmod u+w {} \;
58	rm -rf $work
59	exit 0
60}
61fail()
62{
63	set +x
64	echo 'FAILED test of the aesub switch functionality' 1>&2
65	cd $here
66	find $work -type d -user $USER -exec chmod u+w {} \;
67	rm -rf $work
68	exit 1
69}
70no_result()
71{
72	set +x
73	echo 'NO RESULT when testing the aesub switch functionality' 1>&2
74	cd $here
75	find $work -type d -user $USER -exec chmod u+w {} \;
76	rm -rf $work
77	exit 2
78}
79trap \"no_result\" 1 2 3 15
80
81mkdir $work $work/lib
82if test $? -ne 0 ; then no_result; fi
83chmod 777 $work/lib
84if test $? -ne 0 ; then no_result; fi
85cd $work
86if test $? -ne 0 ; then no_result; fi
87
88#
89# use the built-in error messages
90#
91AEGIS_MESSAGE_LIBRARY=$work/no-such-dir
92export AEGIS_MESSAGE_LIBRARY
93unset LANG
94unset LANGUAGE
95
96$bin/aegis -newproj example -version - -lib $work/lib -dir $work/proj
97if test $? -ne 0 ; then no_result; fi
98
99AEGIS_PROJECT=example
100export AEGIS_PROJECT
101AEGIS_PATH=$work/lib
102export AEGIS_PATH
103
104cat > ca << 'fubar'
105description = "short";
106brief_description = "short";
107cause = internal_enhancement;
108fubar
109if test $? -ne 0 ; then no_result; fi
110
111$bin/aegis -newchan 42 -p example -f ca
112if test $? -ne 0 ; then no_result; fi
113
114AEGIS_CHANGE=42
115export AEGIS_CHANGE
116
117#
118# test the aesub switch functionality
119#
120echo zero > test.ok
121if test $? -ne 0 ; then no_result; fi
122$bin/aesub '${switch 0 zero one two three four}' > test.out
123if test $? -ne 0 ; then fail; fi
124diff test.ok test.out
125if test $? -ne 0 ; then fail; fi
126
127echo one > test.ok
128if test $? -ne 0 ; then no_result; fi
129$bin/aesub '${switch 1 zero one two three four}' > test.out
130if test $? -ne 0 ; then fail; fi
131diff test.ok test.out
132if test $? -ne 0 ; then fail; fi
133
134echo four > test.ok
135if test $? -ne 0 ; then no_result; fi
136$bin/aesub '${switch 9 zero one two three four}' > test.out
137if test $? -ne 0 ; then fail; fi
138diff test.ok test.out
139if test $? -ne 0 ; then fail; fi
140
141#
142# Only definite negatives are possible.
143# The functionality exercised by this test appears to work,
144# no other guarantees are made.
145#
146pass
147